
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Skin_care_logsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const skin_care_logs = await db.skin_care_logs.create(
            {
                id: data.id || undefined,
        
        logged_at: data.logged_at
        ||
        null
            ,
            
        routine_time: data.routine_time
        ||
        null
            ,
            
        products_used: data.products_used
        ||
        null
            ,
            
        oiliness: data.oiliness
        ||
        null
            ,
            
        dryness: data.dryness
        ||
        null
            ,
            
        redness: data.redness
        ||
        null
            ,
            
        breakout_locations: data.breakout_locations
        ||
        null
            ,
            
        sensitivity: data.sensitivity
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await skin_care_logs.setUser( data.user || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.skin_care_logs.getTableName(),
                belongsToColumn: 'skin_photos',
                belongsToId: skin_care_logs.id,
            },
            data.skin_photos,
            options,
        );
        

        return skin_care_logs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const skin_care_logsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                logged_at: item.logged_at
            ||
            null
            ,
            
                routine_time: item.routine_time
            ||
            null
            ,
            
                products_used: item.products_used
            ||
            null
            ,
            
                oiliness: item.oiliness
            ||
            null
            ,
            
                dryness: item.dryness
            ||
            null
            ,
            
                redness: item.redness
            ||
            null
            ,
            
                breakout_locations: item.breakout_locations
            ||
            null
            ,
            
                sensitivity: item.sensitivity
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const skin_care_logs = await db.skin_care_logs.bulkCreate(skin_care_logsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < skin_care_logs.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.skin_care_logs.getTableName(),
                    belongsToColumn: 'skin_photos',
                    belongsToId: skin_care_logs[i].id,
                },
                data[i].skin_photos,
                options,
            );
        }
        

        return skin_care_logs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const skin_care_logs = await db.skin_care_logs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.logged_at !== undefined) updatePayload.logged_at = data.logged_at;
        
        
        if (data.routine_time !== undefined) updatePayload.routine_time = data.routine_time;
        
        
        if (data.products_used !== undefined) updatePayload.products_used = data.products_used;
        
        
        if (data.oiliness !== undefined) updatePayload.oiliness = data.oiliness;
        
        
        if (data.dryness !== undefined) updatePayload.dryness = data.dryness;
        
        
        if (data.redness !== undefined) updatePayload.redness = data.redness;
        
        
        if (data.breakout_locations !== undefined) updatePayload.breakout_locations = data.breakout_locations;
        
        
        if (data.sensitivity !== undefined) updatePayload.sensitivity = data.sensitivity;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await skin_care_logs.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await skin_care_logs.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.skin_care_logs.getTableName(),
                belongsToColumn: 'skin_photos',
                belongsToId: skin_care_logs.id,
            },
            data.skin_photos,
            options,
        );
        

        return skin_care_logs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const skin_care_logs = await db.skin_care_logs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of skin_care_logs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of skin_care_logs) {
                await record.destroy({transaction});
            }
        });


        return skin_care_logs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const skin_care_logs = await db.skin_care_logs.findByPk(id, options);

        await skin_care_logs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await skin_care_logs.destroy({
            transaction
        });

        return skin_care_logs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const skin_care_logs = await db.skin_care_logs.findOne(
            { where },
            { transaction },
        );

        if (!skin_care_logs) {
            return skin_care_logs;
        }

        const output = skin_care_logs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await skin_care_logs.getUser({
            transaction
        });
        
        
        output.skin_photos = await skin_care_logs.getSkin_photos({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'skin_photos',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.products_used) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'skin_care_logs',
                        'products_used',
                        filter.products_used,
                    ),
                };
            }
            
            if (filter.breakout_locations) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'skin_care_logs',
                        'breakout_locations',
                        filter.breakout_locations,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'skin_care_logs',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            logged_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    logged_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.logged_atRange) {
                const [start, end] = filter.logged_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    logged_at: {
                    ...where.logged_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    logged_at: {
                    ...where.logged_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.oilinessRange) {
                const [start, end] = filter.oilinessRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    oiliness: {
                    ...where.oiliness,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    oiliness: {
                    ...where.oiliness,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.drynessRange) {
                const [start, end] = filter.drynessRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    dryness: {
                    ...where.dryness,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    dryness: {
                    ...where.dryness,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rednessRange) {
                const [start, end] = filter.rednessRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    redness: {
                    ...where.redness,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    redness: {
                    ...where.redness,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sensitivityRange) {
                const [start, end] = filter.sensitivityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sensitivity: {
                    ...where.sensitivity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sensitivity: {
                    ...where.sensitivity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.routine_time) {
                where = {
                    ...where,
                routine_time: filter.routine_time,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.skin_care_logs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'skin_care_logs',
                        'products_used',
                        query,
                    ),
                ],
            };
        }

        const records = await db.skin_care_logs.findAll({
            attributes: [ 'id', 'products_used' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['products_used', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.products_used,
        }));
    }

    
};

